#ifndef CF_H
#define CF_H

#define CMD_BYTE(a)  (a << 5)

// address register control bits
#define CF_RESET       0x8000
#define CF_ADDR_TOGGLE 0x2000
#define CF_ADDR_BINC   0x4000
#define CF_ADDR_WINC   0x6000
#define CF_ADDR_MASK   0x07ff

#define GET_ID     0
#define SET_ADDR   1
#define REG_READ   2 
#define REG_WRITE  3
#define IO_READ    4
#define IO_WRITE   5
#define MEM_READ   6
#define MEM_WRITE  7

void cf_get_id(void);

void cf_reset(void);
void cf_set_addr(uint16_t addr);

void cf_reg_read(uint16_t addr, char *dst, uint16_t bytes);
unsigned char cf_reg_read_byte(uint16_t addr);
uint16_t cf_reg_read_word(uint16_t addr);
void cf_reg_write_byte(uint16_t addr, unsigned char byte);

uint16_t cf_io_read_word(uint16_t addr);
void cf_io_write_word(uint16_t addr, uint16_t val);
void cf_io_read(uint16_t addr, uint16_t *dst, uint16_t words);
void cf_io_write(uint16_t addr, uint16_t *src, uint16_t words);

#endif // CF_H
